@ECHO OFF
REM UO Version Extraction by Batlin
REM
REM REQUIRES:
REM   fvertest
REM   sed
REM   strings

REM Parameter checking
IF %1.==. GOTO :Help
IF NOT EXIST %1 GOTO :Error
GOTO :DoIt

:Help
ECHO Usage: uoversion ^<UO-client-exe-filename^>
GOTO :Done

:Error
ECHO Client file does not exist!
GOTO :Done

:DoIt
REM Tools:
REM   http://technet.microsoft.com/en-us/sysinternals/bb897439.aspx
REM   http://gnuwin32.sourceforge.net/packages/sed.htm

REM Tutorial:
REM   http://users.cybercity.dk/~bse26236/batutil/help/SED.HTM

REM Do we have a version resource?
fvertest -q %1 > NUL
IF %ERRORLEVEL% EQU 0 goto :technique_fvertest

:technique_strings
REM No...
REM   1: extract all ascii strings
REM   2: look for and extract the version number
REM   3: fix-up (alpha client, returned value is probably bogus)
REM   4: fix-up (GOD client, maybe others too)
strings -a -q %1 | sed -e "/^[1-5]\.[0-9]\{1,2\}.*$/!d" | sed /[_]/d | sed 1!d
GOTO :done

:technique_fvertest
REM Yes...
REM   1: extract the version string
REM   2: clean-up
fvertest -f %1 | sed -e "s/^.*\[\(.*\)\].*$/\1/"
ECHO.

:Done